src/Entity/Reservation.php
<?php

namespace App\Entity;

use App\Repository\ReservationRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=ReservationRepository::class)
 */
class Reservation
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity=Client::class, inversedBy="reservations")
     * @ORM\JoinColumn(nullable=false)
     */
    private $id_client;

    /**
     * @ORM\ManyToOne(targetEntity=Chambre::class, inversedBy="reservations")
     * @ORM\JoinColumn(nullable=false)
     */
    private $id_chambre;

    /**
     * @ORM\Column(type="string")
     */
    private $date_arr;

    /**
     * @ORM\Column(type="string")
     */
    private $date_dep;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getIdClient(): ?Client
    {
        return $this->id_client;
    }

    public function setIdClient(?Client $id_client): self
    {
        $this->id_client = $id_client;

        return $this;
    }

    public function getIdChambre(): ?Chambre
    {
        return $this->id_chambre;
    }

    public function setIdChambre(?Chambre $id_chambre): self
    {
        $this->id_chambre = $id_chambre;

        return $this;
    }

    public function getDateArr()
    {
        return $this->date_arr;
    }

    public function setDateArr( $date_arr): self
    {
        $this->date_arr = $date_arr;

        return $this;
    }

    public function getDateDep()
    {
        return $this->date_dep;
    }

    public function setDateDep($date_dep): self
    {
        $this->date_dep = $date_dep;

        return $this;
    }
}

src/Form/ReservationType.php
<?php

namespace App\Form;

use App\Entity\Reservation;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class ReservationType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('date_arr',TextType::class)
            ->add('date_dep',TextType::class)
            ->add('id_client')
            ->add('id_chambre')
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Reservation::class,
        ]);
    }
}

src/Controller/ReservationController.php
<?php

namespace App\Controller;

use App\Entity\Reservation;
use App\Form\ReservationType;
use App\Repository\ReservationRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/reservation")
 */
class ReservationController extends AbstractController
{
    /**
     * @Route("/", name="reservation_index", methods={"GET"})
     */
    public function index(ReservationRepository $reservationRepository): Response
    {
        return $this->render('reservation/index.html.twig', [
            'reservations' => $reservationRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="reservation_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $reservation = new Reservation();
        $form = $this->createForm(ReservationType::class, $reservation);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($reservation);
            $entityManager->flush();

            return $this->redirectToRoute('reservation_index');
        }

        return $this->render('reservation/new.html.twig', [
            'reservation' => $reservation,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="reservation_show", methods={"GET"})
     */
    public function show(Reservation $reservation): Response
    {
        return $this->render('reservation/show.html.twig', [
            'reservation' => $reservation,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="reservation_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, Reservation $reservation): Response
    {
        $form = $this->createForm(ReservationType::class, $reservation);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('reservation_index');
        }

        return $this->render('reservation/edit.html.twig', [
            'reservation' => $reservation,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="reservation_delete", methods={"DELETE"})
     */
    public function delete(Request $request, Reservation $reservation): Response
    {
        if ($this->isCsrfTokenValid('delete'.$reservation->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($reservation);
            $entityManager->flush();
        }

        return $this->redirectToRoute('reservation_index');
    }
}

templates/reservation/_delete_form.html.twig
<form style="display: none;" id="form1" method="post" action="{{ path('reservation_delete', {'id': reservation.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_method" value="DELETE">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ reservation.id) }}">
    <button class="btn btndelete-form">Delete</button>
</form>

templates/reservation/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/reservation/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Reservation{% endblock %}
{% block css %}
    <link rel="stylesheet" href="{{ asset('range/daterangepicker.min.css') }}">
{% endblock %}
{% block content %}
    <div class="row d-flex justify-content-center">
        <div class="col-md-6 col-12 ">
            <div class="card" style="height: 392.688px;">

                <div class="card-content">
                    <div class="card-body">
                        {{ form_start(form) }}
                        <div class="form-body">
                            <div class="row">
                                <div class="col-md-4">
                                    {{ form_label(form.date_arr, 'Date arrivé') }}
                                </div>
                                <div class="col-md-8 form-group ">
                                    <div class="position-relative has-icon-left">
                                        {{ form_widget(form.date_arr ,{ 'attr': {'class': 'form-control date1','data-datepicker': 'separateRange'}  }) }}
                                        <div class="form-control-position">
                                            <i class="bx bx-calendar-check"></i>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    {{ form_label(form.date_dep, 'Date arrivé') }}
                                </div>
                                <div class="col-md-8 form-group">
                                    <div class="position-relative has-icon-left">
                                        {{ form_widget(form.date_dep ,{ 'attr': {'class': 'form-control date2','data-datepicker': 'separateRange'}  }) }}
                                        <div class="form-control-position">
                                            <i class="bx bx-calendar-x"></i>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    {{ form_label(form.id_client, 'Client') }}
                                </div>
                                <div class="col-md-8 form-group">
                                    <div class="position-relative has-icon-left">
                                        {{ form_widget(form.id_client ,{ 'attr': {'class': 'form-control '}  }) }}
                                        <div class="form-control-position">
                                            <i class="bx bx-user"></i>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    {{ form_label(form.id_chambre, 'Chambre') }}
                                </div>
                                <div class="col-md-8 form-group">
                                    <div class="position-relative has-icon-left">
                                        {{ form_widget(form.id_chambre ,{ 'attr': {'class': 'form-control '}  }) }}
                                        <div class="form-control-position">
                                            <i class="bx bx-bed"></i>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-12 d-flex justify-content-end ">
                                    <button class="btn btn-primary" type="submit"> {{ button_label|default('Soumettre') }}</button>
                                </div>
                            </div>
                        </div>
                        {{ form_end(form) }}
                    </div>
                </div>
            </div>
        </div>
    </div>


{% endblock %}
{% block js %}
    <script src="{{ asset('range/daterangepicker.min.js') }}"></script>
    <script>
        if($('#reservation_date_arr, #reservation_date_dep').length){
            // check if element is available to bind ITS ONLY ON HOMEPAGE
            var currentDate = moment().format("DD-MM-YYYY");

            $('#reservation_date_arr, #reservation_date_dep').daterangepicker({
                locale: {
                    format: 'DD-MM-YYYY'
                },
                "alwaysShowCalendars": true,
                "minDate": currentDate,
                autoApply: true,
                autoUpdateInput: false
            }, function(start, end, label) {
                // console.log("New date range selected: ' + start.format('YYYY-MM-DD') + ' to ' + end.format('YYYY-MM-DD') + ' (predefined range: ' + label + ')");
                // Lets update the fields manually this event fires on selection of range
                var selectedStartDate = start.format('DD-MM-YYYY'); // selected start
                var selectedEndDate = end.format('DD-MM-YYYY'); // selected end

                $checkinInput = $('#reservation_date_arr');
                $checkoutInput = $('#reservation_date_dep');

                // Updating Fields with selected dates
                $checkinInput.val(selectedStartDate);
                $checkoutInput.val(selectedEndDate);

                // Setting the Selection of dates on calender on CHECKOUT FIELD (To get this it must be binded by Ids not Calss)
                var checkOutPicker = $checkoutInput.data('daterangepicker');
                checkOutPicker.setStartDate(selectedStartDate);
                checkOutPicker.setEndDate(selectedEndDate);

                // Setting the Selection of dates on calender on CHECKIN FIELD (To get this it must be binded by Ids not Calss)
                var checkInPicker = $checkinInput.data('daterangepicker');
                checkInPicker.setStartDate(selectedStartDate);
                checkInPicker.setEndDate(selectedEndDate);

            });

        } // End Daterange Picker
    </script>
{% endblock %}

templates/reservation/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Reservation index{% endblock %}
{% block css %}
    <link rel="stylesheet" type="text/css" href="{{ asset('app-assets/vendors/css/vendors.min.css') }}">
    <link rel="stylesheet" type="text/css" href="//cdn.datatables.net/1.10.21/css/jquery.dataTables.min.css">
{% endblock %}
{% block content %}
    <!-- Zero configuration table -->
    <section id="basic-datatable">
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-content">
                        <div class="card-body card-dashboard">
                            <div class="table-responsive">
                                <table class="table reservation">
                                    <thead>
                                    <tr>
                                        <th>Date arrivé</th>
                                        <th>Date départ</th>
                                        <th>Client</th>
                                        <th>Chambre</th>
                                        <th class="text-right">Actions</th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    {% for reservation in reservations %}
                                        <tr>
                                            <td>{{ reservation.dateArr }}</td>
                                            <td>{{ reservation.dateDep }}</td>
                                            <td>{{ reservation.idClient.nom }}</td>
                                            <td>{{ reservation.idChambre.number }}</td>
                                            <td >
                                                <a  data-toggle="modal" data-target="#border-less{{ reservation.id }}" class="btn btn-group-sm btn-icon btn-info "><i class="bx bxs-search"></i></a>
                                                <a  href="{{ path('reservation_edit', {'id': reservation.id}) }}" class="btn btn-icon btn-group-sm  btn-warning "><i class="bx bx-pen"></i></a>
                                                <a   href="#" onclick="document.getElementById('form1').submit();" class="btn btn-group-sm  btn-icon btn-danger "><i class="bx bx-trash"></i></a>
                                                {{ include('reservation/_delete_form.html.twig') }}
                                            </td>
                                        </tr>
                                        <div class="modal fade text-left modal-borderless" id="border-less{{ reservation.id }}" tabindex="-1" role="dialog" aria-labelledby="myModalLabel{{ reservation.id }}" aria-hidden="true">
                                            <div class="modal-dialog modal-dialog-scrollable" role="document">
                                                <div class="modal-content">
                                                    <div class="modal-header">
                                                        <h3 class="modal-title"><span class="badge badge-info">{{ reservation.id }}</span></h3>
                                                        <button type="button" class="close rounded-pill" data-dismiss="modal" aria-label="Close">
                                                            <i class="bx bx-x"></i>
                                                        </button>
                                                    </div>
                                                    <div class="modal-body">
                                                        <div class="col-xl-12 col-md-6 col-12 whether">
                                                            <div class="card">
                                                                <div class="card-header">
                                                                    <div>
                                                                        <h3 class="font-weight-normal mb-0">date d'arrivé: {{ reservation.dateArr }}</h3>
                                                                        <h3 class="font-weight-normal mb-0">date de sortie: {{ reservation.dateDep }}</h3>
                                                                    </div>
                                                                    <div class="heading-elements">
                                                                        <i class="bx bx-rotate-right font-medium-4"></i>
                                                                    </div>
                                                                </div>
                                                                <div class="card-content">
                                                                    <div class="card-body">
                                                                        <div class="d-flex align-items-center justify-content-between">
                                                                            <div>
                                                                                <p class="mb-0"><span class="badge badge-{% if reservation.idChambre.comfort==0 %}danger{% else %}success{% endif %}">{% if reservation.idChambre.comfort==0 %}<DEL>comfort</DEL>{% else %}comfort{% endif %}</span></p>

                                                                            </div>
                                                                            <i class="bx bx-hotel font-large-2"></i>
                                                                        </div>
                                                                        <hr>
                                                                        <div class="d-flex align-items-center justify-content-around">
                                                                            <div class="d-flex flex-column align-items-center">
                                                                                <small class="text-muted">Clients</small>
                                                                                <i class="bx bx-user-circle text-bold-700 font-medium-2 my-50"></i>
                                                                                <small class="text-muted">{{ reservation.idClient.nom }}</small>
                                                                            </div>
                                                                            <div class="d-flex flex-column align-items-center">
                                                                                <small class="text-muted">Chambre</small>
                                                                                <i class="bx bx-hotel font-medium-2 my-50"></i>
                                                                                <small class="text-muted">{{ reservation.idChambre.number }}</small>
                                                                            </div>
                                                                        </div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="modal-footer">
                                                        <button type="button" class="btn btn-light-primary" data-dismiss="modal">
                                                            <i class="bx bx-x d-block d-sm-none"></i>
                                                            <span class="d-none d-sm-block">Close</span>
                                                        </button>
                                                        <button type="button" class="btn btn-primary ml-1" data-dismiss="modal">
                                                            <i class="bx bx-check d-block d-sm-none"></i>
                                                            <span class="d-none d-sm-block">Accept</span>
                                                        </button>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                    {% endfor %}
                                    </tbody>
                                    <tfoot>
                                    <tr>
                                        <th>Date arrivé</th>
                                        <th>Date départ</th>
                                        <th>Client</th>
                                        <th>Chambre</th>
                                        <th class="text-right">Actions</th>
                                    </tr>
                                    </tfoot>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <!--/ Zero configuration table -->
{% endblock %}
{% block js  %}
    <script src="{{ asset('app-assets/vendors/js/tables/datatable/datatables.min.js') }}"></script>
    <script src="{{ asset('app-assets/vendors/js/tables/datatable/dataTables.bootstrap4.min.js') }}"></script>
    <script src="{{ asset('app-assets/vendors/js/tables/datatable/dataTables.buttons.min.js') }}"></script>
    <script src="{{ asset('app-assets/vendors/js/tables/datatable/buttons.html5.min.js') }}"></script>
{#    <script src="{{ asset('app-assets/vendors/js/tables/datatable/buttons.print.min.js') }}"></script>#}
    <script src="{{ asset('app-assets/vendors/js/tables/datatable/buttons.bootstrap.min.js') }}"></script>
{#    <script src="{{ asset('app-assets/vendors/js/tables/datatable/pdfmake.min.js') }}"></script>#}
{#    <script src="{{ asset('app-assets/vendors/js/tables/datatable/vfs_fonts.js') }}"></script>#}
    <script src="{{ asset('app-assets/vendors/js/scripts/datatable/datatables.min.js') }}"></script>
    <script>
        $('.reservation').DataTable();
    </script>
{% endblock %}

templates/reservation/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Reservation{% endblock %}
{% block css %}
    <link rel="stylesheet" href="{{ asset('range/daterangepicker.min.css') }}">
{% endblock %}
{% block content %}
    <div class="row d-flex justify-content-center">
        <div class="col-md-6 col-12 ">
            <div class="card" style="height: 392.688px;">

                <div class="card-content">
                    <div class="card-body">
                        {{ form_start(form) }}
                        <div class="form-body">
                            <div class="row">
                                <div class="col-md-4">
                                    {{ form_label(form.date_arr, 'Date arrivé') }}
                                </div>
                                <div class="col-md-8 form-group ">
                                    <div class="position-relative has-icon-left">
                                        {{ form_widget(form.date_arr ,{ 'attr': {'class': 'form-control date1','data-datepicker': 'separateRange'}  }) }}
                                        <div class="form-control-position">
                                            <i class="bx bx-calendar-check"></i>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    {{ form_label(form.date_dep, 'Date arrivé') }}
                                </div>
                                <div class="col-md-8 form-group">
                                    <div class="position-relative has-icon-left">
                                        {{ form_widget(form.date_dep ,{ 'attr': {'class': 'form-control date2','data-datepicker': 'separateRange'}  }) }}
                                        <div class="form-control-position">
                                            <i class="bx bx-calendar-x"></i>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    {{ form_label(form.id_client, 'Client') }}
                                </div>
                                <div class="col-md-8 form-group">
                                    <div class="position-relative has-icon-left">
                                        {{ form_widget(form.id_client ,{ 'attr': {'class': 'form-control '}  }) }}
                                        <div class="form-control-position">
                                            <i class="bx bx-user"></i>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    {{ form_label(form.id_chambre, 'Chambre') }}
                                </div>
                                <div class="col-md-8 form-group">
                                    <div class="position-relative has-icon-left">
                                        {{ form_widget(form.id_chambre ,{ 'attr': {'class': 'form-control '}  }) }}
                                        <div class="form-control-position">
                                            <i class="bx bx-bed"></i>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-12 d-flex justify-content-end ">
                                    <button class="btn btn-primary" type="submit"> {{ button_label|default('Soumettre') }}</button>
                                </div>
                            </div>
                        </div>
                        {{ form_end(form) }}
                    </div>
                </div>
            </div>
        </div>
    </div>



{% endblock %}
{% block js %}
    <script src="{{ asset('app-assets/css/moment.min.js') }}"></script>
    <script src="{{ asset('range/daterangepicker.min.js') }}"></script>

    <script>
        if($('#reservation_date_arr, #reservation_date_dep').length){
            // check if element is available to bind ITS ONLY ON HOMEPAGE
            var currentDate = moment().format("DD-MM-YYYY");

            $('#reservation_date_arr, #reservation_date_dep').daterangepicker({
                locale: {
                    format: 'DD-MM-YYYY'
                },
                "alwaysShowCalendars": true,
                "minDate": currentDate,
                autoApply: true,
                autoUpdateInput: false
            }, function(start, end, label) {
                // console.log("New date range selected: ' + start.format('YYYY-MM-DD') + ' to ' + end.format('YYYY-MM-DD') + ' (predefined range: ' + label + ')");
                // Lets update the fields manually this event fires on selection of range
                var selectedStartDate = start.format('DD-MM-YYYY'); // selected start
                var selectedEndDate = end.format('DD-MM-YYYY'); // selected end

                $checkinInput = $('#reservation_date_arr');
                $checkoutInput = $('#reservation_date_dep');

                // Updating Fields with selected dates
                $checkinInput.val(selectedStartDate);
                $checkoutInput.val(selectedEndDate);

                // Setting the Selection of dates on calender on CHECKOUT FIELD (To get this it must be binded by Ids not Calss)
                var checkOutPicker = $checkoutInput.data('daterangepicker');
                checkOutPicker.setStartDate(selectedStartDate);
                checkOutPicker.setEndDate(selectedEndDate);

                // Setting the Selection of dates on calender on CHECKIN FIELD (To get this it must be binded by Ids not Calss)
                var checkInPicker = $checkinInput.data('daterangepicker');
                checkInPicker.setStartDate(selectedStartDate);
                checkInPicker.setEndDate(selectedEndDate);

            });

        } // End Daterange Picker
    </script>
{% endblock %}